# Class AncestorEvent

java.lang.Object
java.util.EventObject
java.awt.AWTEvent
javax.swing.event.AncestorEvent

All Implemented Interfaces:
  `Serializable`

public class AncestorEvent extends AWTEvent
An event reported to a child component that originated from an ancestor in the component hierarchy.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ANCESTOR_ADDED`
An ancestor-component was added to the hierarchy of visible objects (made visible), and is currently being displayed.
`static final int`
`ANCESTOR_MOVED`
An ancestor-component changed its position on the screen.
`static final int`
`ANCESTOR_REMOVED`
An ancestor-component was removed from the hierarchy of visible objects (hidden) and is no longer being displayed.

### Fields declared in class AWTEvent

`ACTION_EVENT_MASK, ADJUSTMENT_EVENT_MASK, COMPONENT_EVENT_MASK, consumed, CONTAINER_EVENT_MASK, FOCUS_EVENT_MASK, HIERARCHY_BOUNDS_EVENT_MASK, HIERARCHY_EVENT_MASK, id, INPUT_METHOD_EVENT_MASK, INVOCATION_EVENT_MASK, ITEM_EVENT_MASK, KEY_EVENT_MASK, MOUSE_EVENT_MASK, MOUSE_MOTION_EVENT_MASK, MOUSE_WHEEL_EVENT_MASK, PAINT_EVENT_MASK, RESERVED_ID_MAX, TEXT_EVENT_MASK, WINDOW_EVENT_MASK, WINDOW_FOCUS_EVENT_MASK, WINDOW_STATE_EVENT_MASK`
Modifier and Type
Field
Description
`static final long`
`ACTION_EVENT_MASK`
The event mask for selecting action events.
`static final long`
`ADJUSTMENT_EVENT_MASK`
The event mask for selecting adjustment events.
`static final long`
`COMPONENT_EVENT_MASK`
The event mask for selecting component events.
`protected boolean`
`consumed`
Controls whether or not the event is sent back down to the peer once the source has processed it - false means it's sent to the peer; true means it's not.
`static final long`
`CONTAINER_EVENT_MASK`
The event mask for selecting container events.
`static final long`
`FOCUS_EVENT_MASK`
The event mask for selecting focus events.
`static final long`
`HIERARCHY_BOUNDS_EVENT_MASK`
The event mask for selecting hierarchy bounds events.
`static final long`
`HIERARCHY_EVENT_MASK`
The event mask for selecting hierarchy events.
`protected int`
`id`
The event's id.
`static final long`
`INPUT_METHOD_EVENT_MASK`
The event mask for selecting input method events.
`static final long`
`INVOCATION_EVENT_MASK`
The event mask for selecting invocation events.
`static final long`
`ITEM_EVENT_MASK`
The event mask for selecting item events.
`static final long`
`KEY_EVENT_MASK`
The event mask for selecting key events.
`static final long`
`MOUSE_EVENT_MASK`
The event mask for selecting mouse events.
`static final long`
`MOUSE_MOTION_EVENT_MASK`
The event mask for selecting mouse motion events.
`static final long`
`MOUSE_WHEEL_EVENT_MASK`
The event mask for selecting mouse wheel events.
`static final long`
`PAINT_EVENT_MASK`
The event mask for selecting paint events.
`static final int`
`RESERVED_ID_MAX`
The maximum value for reserved AWT event IDs.
`static final long`
`TEXT_EVENT_MASK`
The event mask for selecting text events.
`static final long`
`WINDOW_EVENT_MASK`
The event mask for selecting window events.
`static final long`
`WINDOW_FOCUS_EVENT_MASK`
The event mask for selecting window focus events.
`static final long`
`WINDOW_STATE_EVENT_MASK`
The event mask for selecting window state events.

### Fields declared in class EventObject

`source`
Modifier and Type
Field
Description
`protected Object`
`source`
The object on which the Event initially occurred.

## Constructor Summary

Constructors
Constructor
Description
`AncestorEvent(JComponent source, int id, Container ancestor, Container ancestorParent)`
Constructs an AncestorEvent object to identify a change in an ancestor-component's display-status.

## Method Summary

Modifier and Type
Method
Description
`Container`
`getAncestor()`
Returns the ancestor that the event actually occurred on.
`Container`
`getAncestorParent()`
Returns the parent of the ancestor the event actually occurred on.
`JComponent`
`getComponent()`
Returns the component that the listener was added to.

### Methods declared in class AWTEvent

`consume, getID, isConsumed, paramString, setSource, toString`
Modifier and Type
Method
Description
`protected void`
`consume()`
Consumes this event, if this event can be consumed.
`int`
`getID()`
Returns the event type.
`protected boolean`
`isConsumed()`
Returns whether this event has been consumed.
`String`
`paramString()`
Returns a string representing the state of this `Event`.
`void`
`setSource(Object newSource)`
Retargets an event to a new source.
`String`
`toString()`
Returns a String representation of this object.

### Methods declared in class EventObject

`getSource`
Modifier and Type
Method
Description
`Object`
`getSource()`
The object on which the Event initially occurred.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### ANCESTOR_ADDED

public static final int ANCESTOR_ADDED
An ancestor-component was added to the hierarchy of visible objects (made visible), and is currently being displayed.

See Also:
  - Constant Field Values

### ANCESTOR_REMOVED

public static final int ANCESTOR_REMOVED
An ancestor-component was removed from the hierarchy of visible objects (hidden) and is no longer being displayed.

See Also:
  - Constant Field Values

### ANCESTOR_MOVED

public static final int ANCESTOR_MOVED
An ancestor-component changed its position on the screen.

See Also:
  - Constant Field Values

## Constructor Details

### AncestorEvent

public AncestorEvent(JComponent source, int id, Container ancestor, Container ancestorParent)
Constructs an AncestorEvent object to identify a change in an ancestor-component's display-status.

Parameters:
  `source` - the JComponent that originated the event (typically `this`)
  `id` - an int specifying `ANCESTOR_ADDED`, `ANCESTOR_REMOVED` or `ANCESTOR_MOVED`
  `ancestor` - a Container object specifying the ancestor-component whose display-status changed
  `ancestorParent` - a Container object specifying the ancestor's parent

## Method Details

### getAncestor

public Container getAncestor()
Returns the ancestor that the event actually occurred on.

Returns:
  the `Container` object specifying the ancestor component

### getAncestorParent

public Container getAncestorParent()
Returns the parent of the ancestor the event actually occurred on. This is most interesting in an ANCESTOR_REMOVED event, as the ancestor may no longer be in the component hierarchy.

Returns:
  the `Container` object specifying the ancestor's parent

### getComponent

public JComponent getComponent()
Returns the component that the listener was added to.

Returns:
  the `JComponent` on which the event occurred